program All_kinds_of_very_basic_stuff_using_regs_and_asm;
uses crt, dos, graph;

{  Hi! This is version 0.01 of "All_kinds_of..." by Kru$H Productions     }
{  It's really not much, but it should help beginners struggling with      }
{  registers, inline-code and asm. There are some procedures that are      }
{  not used, but I left them there anyway for you to look at. If you       }
{  really wnat to learn how to use interrupts, i recommend gettting some   }
{  sort of interrupt list (actually, you have to have one.) If this        }
{  program makes your houseplants eat you at night while you are           }
{  innocently asleep, or makes everyone throw big rocks at you, i have     }
{  nothing to do with it.  That's about all for today...     Kru$H -95     }

var  i,gM,gT   : integer;
     regs      : registers;
     x,y,x1,y1 : Integer;


procedure TPinitmode(mode : byte);          { This for Normal screen modes.}
begin
  with regs do
    begin
    ah := $00;
    al := mode;
    end;
  intr($10, regs)
end;

procedure ASMinitmode (mode : byte);        { Same as above except done    }
begin                                       { with assembler.              }
  asm
    Mov  AH,00
    Mov  AL,mode
    Int  10h
  end;
end;


Procedure ASMsvgamode ( Mode : word );      { This for SVGA screen modes.  }
Begin                                       { Note that the mode is a word }
  Asm                                       { and not a byte.              }
    Mov  AX,4F02h                           { For those of you with no asm }
    Mov  BX,Mode                            { experience, AX=4F02 is the   }
    Int  10h                                { as AH=4F and AL=02.          }
  end;
end;

procedure cls( color:byte);        { This one hell of a procedure all      }
begin                              { for just clearing the screen...       }
 with regs do begin                { What a waste of  time, energy and     }
  ah := $07;                       { chocolate. Anyway... the AH could     }
  al := $00;                       { just as well be $06. What this        }
  cx := $0000;                     { actually does is scroll the screen    }
  dh := $50;                       { down. Difficult.. eh?                 }
  dl := $63;                       { CH, CL = upper left corner of area    }
  bh := color;                     { DH, DL = lower right corner of area   }
 end;                              { AL = how much of area to scroll       }
Intr($10, regs);                   { (00 means the whole area.)            }
end;                               { BH = color. Then we just call int 10. }


procedure TPputpixel (x,y:word ; color:byte);   { Putpixel procedure done  }
begin                                           { as basic TP.             }
  with regs do begin
    ah := $0C;
    al := color;
    cx := x;
    dx := y;
  end;
  intr($10, regs);                              { This is the magic line.. }
end;                                            { It calls the necessary   }
                                                { interrupt.               }


procedure ASMputpixel(x,y:word; color:byte);    { Same Putpixel procedure  }
begin                                           { this time executed in    }
  asm                                           { assembler.               }
    Mov  AH,0Ch
    Mov  AL,color                               { Ihope you're getting the }
    Mov  CX,x                                   { hang of this now...      }
    Mov  DX,y                                   { Since it doesn't get any }
    Int  10h                                    { easier.                  }
  End;
end;



procedure MEMputpixel(x,y:word; c:byte);        { Don't worry about this   }
var b:byte;                                     { one if you don't under-  }
begin                                           { stand it. It works only  }
  port[$3c4]:=2; port[$3c5]:=c;                 { in basic resolutions     }
  b:=mem[sega000:y*80+x shr 3];
  mem[sega000:y*80+x shr 3]:=b or (1 shl (7-(x and 7)));
end;

{ No, it's not SEGA_something_or_the_other but SEG A000  (segment)         }

{ Oh.. for learning TP/ASM you'll also need a list of the ports [????],    }
{ memory areas, opcodes and stuff. This is not a commercial, but I         }
{ recommend getting "The MSDOS interrupt list", kept by Ralf Brown.        }


begin
  randomize;
  inline($B8/$02/$4F/$BB/$03/$01/$CD/$10);

{  I figure this might need explaining to all beginners, so I'll          }
{  explain it:   The 'inline' statement tells the computer we want to     }
{  give it some raw machine code. The following hexadecimal numbers are   }
{  the commands. So how do we know what each command does ?               }
{  Well... it's quite simple if you know how to use assembler and/or      }
{  debug. Just start debug and try typing in the following code:          }

{  (at the dos prompt : DEBUG)                                            }
{  (at the '-' prompt : a100 )                                            }

{  MOV AX,4F02                                                            }
{  MOX BX,103                                                             }
{  INT 10                                                                 }
{  MOV AX,4C00        ...these two lines aren't really necessary          }
{  INT 21             ...unless you want to test your program in dos.     }

{  (Press enter on an empty line to quit inputting code, then write: )    }
{  (R CX   <press enter>                                             )    }
{  (subtract 100 from the last offset address, which is the last four)    }
{  (digits of the last memory address (looks like: ????:010?)        )    }

{  enter this hexadecimal number (which is something like D) at the       }
{  prompt and then write:    n svgamode.com        (this names the code)  }
{  and then:                 w            (this writes the file to disk)  }
{  then write 'u'  This unassembles the file. One step right of the       }
{  memory addresses is the machine code. Take this down and compare with  }
{  the inline statement. You needn't worry about the code for the         }
{  lines after INT 10. That's all.                                        }

{  So what we've got is the ASsvgamode procedure in direct machine code.  }
{  It's short and can be easily copied to all your programs. Note that    }
{  by changing the $03 to something between $00 and $1B you can change    }
{  the resolution.                                                        }

  for i:=0 to 20000 do
     ASMputpixel(random(800), random(600),random(256));
  for i:=0 to 20000 do
     TPputpixel(random(600)+100, random(400)+100, random(256));
  for i:=0 to 20000 do
     ASMputpixel(random(460)+170, random(200)+200, random(256));
  for i:=0 to 20000 do
     TPputpixel(random(250)+275, random(100)+250, random(256));
  for i:=0 to 30000 do
     ASMputpixel(random(800), random(600),0);
  for i:=31 downto 16 do cls(i);                 { This is pretty ugly.   }
end.
